<?php

namespace Test\Ease\Logger;

use Ease\Logger\ToConsole;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2019-08-05 at 05:48:05.
 */
class ToConsoleTest extends ToMemoryTest {

    /**
     * @var ToConsole
     */
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp(): void {
        $this->object = new ToConsole;
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown(): void {
        
    }

    /**
     * Test Constructor
     *
     * @covers \Ease\Logger\ToConsole::__construct
     */
    public function testConstructor() {
        $classname = get_class($this->object);

        // Get mock, without the constructor being called
        $mock = $this->getMockBuilder($classname)
                ->disableOriginalConstructor()
                ->getMockForAbstractClass();

        $mock->__construct();

        $this->assertIsResource($mock->stdout, 'StdOut is not resource');
        $this->assertIsResource($mock->stderr, 'StdErr is not resource');
    }

    /**
     * @covers Ease\Logger\ToConsole::set
     */
    public function testSet() {
        $this->assertEquals("\033[31mred\033[0m", $this->object->set('red', 'red'));
    }

    /**
     * @covers Ease\Logger\ToConsole::addToLog
     * @covers Ease\Logger\Loggingable::addToLog
     */
    public function testAddToLog() {
        $this->assertIsInt($this->object->addToLog($this, 'test'));
        $this->assertIsInt($this->object->addToLog($this, 'test', 'success'));
        $this->assertIsInt($this->object->addToLog($this, 'test error', 'error'));
    }

    /**
     * @covers Ease\Logger\ToConsole::getTypeColor
     */
    public function testGetTypeColor() {
        $this->assertEquals('blue', \Ease\Logger\ToConsole::getTypeColor('mail'));
        $this->assertEquals('yellow', \Ease\Logger\ToConsole::getTypeColor('warning'));
        $this->assertEquals('red', \Ease\Logger\ToConsole::getTypeColor('error'));
        $this->assertEquals('magenta', \Ease\Logger\ToConsole::getTypeColor('debug'));
        $this->assertEquals('green', \Ease\Logger\ToConsole::getTypeColor('success'));
        $this->assertEquals('white', \Ease\Logger\ToConsole::getTypeColor('test'));
    }

    /**
     * @covers Ease\Logger\ToConsole::singleton
     */
    public function testSingleton() {
        $this->assertInstanceOf('\Ease\Logger\ToConsole', \Ease\Logger\ToConsole::singleton());
    }

}
